/*
 * #%L
 * *********************************************************************************************************************
 * 
 * These Foolish Things - Miscellaneous utilities
 * http://thesefoolishthings.java.net - hg clone https://bitbucket.org/tidalwave/thesefoolishthings-src
 * %%
 * Copyright (C) 2009 - 2013 Tidalwave s.a.s. (http://tidalwave.it)
 * %%
 * *********************************************************************************************************************
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 * 
 * *********************************************************************************************************************
 * 
 * $Id: DuplicateException.java,v e7e97a14be7c 2013/02/16 19:44:07 fabrizio $
 * 
 * *********************************************************************************************************************
 * #L%
 */
package it.tidalwave.util;

import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * Notifies that the current operation failed because it would create an illegal duplication (of objects, of ids,
 * etc...)
 *
 * @author  Fabrizio Giudici
 * @version $Id: DuplicateException.java,v e7e97a14be7c 2013/02/16 19:44:07 fabrizio $
 * @it.tidalwave.javadoc.stable
 *
 **********************************************************************************************************************/
public class DuplicateException extends Exception
  {
    /*******************************************************************************************************************
     *
     * Creates a messageless exception.
     *
     ******************************************************************************************************************/
    public DuplicateException()
      {
      }

    /*******************************************************************************************************************
     *
     * Creates an exception with a message.
     *
     * @param  message  the message
     *
     ******************************************************************************************************************/
    public DuplicateException (final @Nonnull String message)
      {
        super(message);
      }
}
